SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core'!

Object subclass: #XeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

XeType subclass: #XeIntType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeIntType commentStamp: 'BernardoContreras 2/27/2012 18:58' prior: 0!
To describe type int!

!XeIntType methodsFor: 'emit code' stamp: 'BernardoContreras 3/20/2012 00:02'!
emitOn: aStream 
	aStream nextPutAll: 'int'! !

!XeType methodsFor: 'emit code' stamp: 'BernardoContreras 3/20/2012 00:02'!
emitOn: aStream
	"emit the string representation of this type on a stream"

	self subclassResponsibility! !

XeType subclass: #XeVoidType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeVoidType commentStamp: 'BernardoContreras 2/27/2012 18:59' prior: 0!
To describe type void!

!XeVoidType methodsFor: 'emit code' stamp: 'BernardoContreras 3/19/2012 22:46'!
emitOn: aStream
	aStream nextPutAll: 'void'! !

Object subclass: #XeTypes
	instanceVariableNames: 'types'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes commentStamp: 'BernardoContreras 3/20/2012 00:19' prior: 0!
Hold all defined types!

XeTypes class
	instanceVariableNames: 'default'!

!XeTypes class methodsFor: 'singleton' stamp: 'BernardoContreras 3/19/2012 23:57'!
default
	^ default ifNil: [ default := self new ]! !

!XeTypes class methodsFor: 'class initialization' stamp: 'BernardoContreras 3/20/2012 00:04'!
initialize
	default := nil! !

!XeTypes class methodsFor: 'cleanup' stamp: 'BernardoContreras 3/19/2012 23:58'!
reset
	"XeTypes reset"

	default := nil! !

!XeTypes methodsFor: 'accessing' stamp: 'BernardoContreras 3/19/2012 23:55'!
at: aSymbol
	^ types at: aSymbol ifAbsent: [ self typeNotFound: aSymbol ]! !

!XeTypes methodsFor: 'initialize-release' stamp: 'BernardoContreras 3/20/2012 00:19'!
initialize
	super initialize.
	types := Dictionary new.
	types at: #int put: XeIntType new.
	types at: #void put: XeVoidType new! !

!XeTypes methodsFor: 'private' stamp: 'BernardoContreras 3/19/2012 23:55'!
typeNotFound: aSymbol
	XeTypeNotFoundError signalFor: aSymbol! !

Object subclass: #Xenon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!Xenon commentStamp: 'BernardoContreras 3/19/2012 22:14' prior: 0!
* Constants are translated only if they are binded in a method.
!

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:31'!
annotatorClass
	^ XeAnnotator! !

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!Xenon methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:37'!
translate: aClass 
	| method stream annotator translator|
	stream := ReadWriteStream on: (String new: 1000).
	method := self parserClass parseMethod: (aClass sourceCodeAt: #main).
	annotator := self annotatorClass new.
	annotator visitNode: method.
	translator := self translatorClass newFor: stream.
	translator visitNode: method.
	^ stream contents! !

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !

RBProgramNodeVisitor subclass: #XeAnnotator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/20/2012 00:20'!
acceptMethodNode: aMethodNode 
	aMethodNode defaultReturnType: #void.
	super acceptMethodNode: aMethodNode.
! !

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/16/2012 01:27'!
acceptPragmaNode: aPragmaNode
	aPragmaNode selector == #returnType: ifTrue: [
		aPragmaNode parent returnType: (aPragmaNode arguments first token value)
		]
	! !

RBProgramNodeVisitor subclass: #XeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 3/16/2012 00:51'!
newFor: aStream 
	^ self new stream: aStream; yourself! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/16/2012 00:57'!
acceptMethodNode: aMethodNode
	aMethodNode returnType emitOn: stream.
	stream space.
	stream nextPutAll: aMethodNode selector asString.
	stream nextPutAll: '(){'; cr.
	stream nextPutAll: '}'.
! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:51'!
stream: aStream 
	stream := aStream! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:03'!
defaultReturnType: typename
	self propertyAt: #defaultReturnType put: typename.! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
hasReturnType
	^ self hasProperty: #returnType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/19/2012 22:49'!
returnType
	^ self hasReturnType
		ifTrue: [ (properties at: #returnType) asXeType]
		ifFalse: [ (properties at: #defaultReturnType) asXeType ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
returnType: typename
	self hasReturnType
		ifTrue: [ 
			XeTooManyReturnTypesError
				signalForSelector: self selector
				class: 'methodNode methodClass asString'
				returnTypes:
					{(self returnType).
					typename} ]
		ifFalse: [ self propertyAt: #returnType put: typename ]! !

!ByteSymbol methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/19/2012 23:18'!
asXeType
	^ XeTypes default at: self
	! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/19/2012 23:43'!
signalForSelector: aSelectorName class: aClassName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , ' in class ' , aClassName , '. actual types: '
		, anArray asString.
	^ self signal: message! !

Error subclass: #XeTypeNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTypeNotFoundError commentStamp: 'BernardoContreras 3/19/2012 23:49' prior: 0!
When a type is not found.
!

!XeTypeNotFoundError class methodsFor: 'signaling' stamp: 'BernardoContreras 3/19/2012 23:43'!
signalFor: aSymbol 

	^ self signal: 'Couldn''t find type: ' , aSymbol.! !
XeTypes initialize!
